GroovyCategorySupport (groovy 2.4.6 API)
Date: 2016-02-18

Package: org.codehaus.groovy.runtime

## [Java] Class GroovyCategorySupport

- org.codehaus.groovy.runtime.GroovyCategorySupport

- Authors:
    sam
    Paul King
    Alex Tkachman

- - ### Nested Class Summary

    Nested classes
    Modifiers | Name | Description
    --- | --- | ---
    `static class` | `GroovyCategorySupport.CategoryMethod` |
    `static class` | `GroovyCategorySupport.CategoryMethodList` |
    `static class` | `GroovyCategorySupport.ThreadCategoryInfo` |

  - ### Methods Summary

    Methods
    Type | Name and description
    --- | ---
    `static GroovyCategorySupport.CategoryMethodList` | `getCategoryMethods(String name)` This method is used to pull all the new methods out of the local thread context with a particular name.
    `static AtomicInteger` | `getCategoryNameUsage(String name)`
    `static String` | `getPropertyCategoryGetterName(String propertyName)`
    `static String` | `getPropertyCategorySetterName(String propertyName)`
    `static boolean` | `hasCategoryInAnyThread()`
    `static boolean` | `hasCategoryInCurrentThread()`
    `static T` | `use(Class categoryClass, Closure<T> closure)` Create a scope based on given categoryClass and invoke closure within that scope.
    `static T` | `use(List<Class> categoryClasses, Closure<T> closure)` Create a scope based on given categoryClasses and invoke closure within that scope.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Method Detail

    - #### public static GroovyCategorySupport.CategoryMethodList getCategoryMethods(String name)

      This method is used to pull all the new methods out of the local thread context with a particular name.

      Parameters:
        `name` - the method name of interest
      Returns:
        the list of methods

    - #### public static AtomicInteger getCategoryNameUsage(String name)

    - #### public static String getPropertyCategoryGetterName(String propertyName)

    - #### public static String getPropertyCategorySetterName(String propertyName)

    - #### public static boolean hasCategoryInAnyThread()

    - #### public static boolean hasCategoryInCurrentThread()

    - #### public static T use(Class categoryClass, Closure<T> closure)

      Create a scope based on given categoryClass and invoke closure within that scope.

      Parameters:
        `categoryClass` - the class containing category methods
        `closure` - the closure during which to make the category class methods available
      Returns:
        the value returned from the closure

    - #### public static T use(List<Class> categoryClasses, Closure<T> closure)

      Create a scope based on given categoryClasses and invoke closure within that scope.

      Parameters:
        `categoryClasses` - the list of classes containing category methods
        `closure` - the closure during which to make the category class methods available
      Returns:
        the value returned from the closure